#include "./H_Group/i2c.h"

#define ADDR_R 0x0d
#define ADDR_W 0x0c
bit i2c_busy = 0; // I2Cæ־λ

// I2Cʼ
void I2C_Init(void)
{
	// I2Cܳʼ
	P_SW2 |= 0x10;	 // лΪڶSDA/SCLӿ
	I2CCFG = 0xff;	 // SPEED31Ӧ52Mhz´Լ393KhzͨѶƵ
	I2CMSCR |= 0x80; // ж
	I2CMSST = 0x00;	 // жϱ־λ
}

// ֹͣź
void I2C_Stop(void)
{
	i2c_busy = 1;
	I2CMSCR = 0x86;
	while (i2c_busy)
		;
}

// I2Cдַ
void I2C_Addr(u8 Addr)
{
	I2CTXD = Addr;
	i2c_busy = 1;
	I2CMSCR = 0x89;
	while (i2c_busy)
		;
}

// I2Cд,ںϽACK
void I2C_Send_Data(u8 Dat)
{
	I2CTXD = Dat;
	i2c_busy = 1;
	I2CMSCR = 0x8a;
	while (i2c_busy)
		;
}

// I2Cݣ滹
u8 I2C_Read_Data()
{
	i2c_busy = 1;
	I2CMSCR = 0x8b;
	while (i2c_busy)
		;
	return I2CRXD;
}

// I2Cݣû
u8 I2C_Read_End()
{
	i2c_busy = 1;
	I2CMSCR = 0x8c;
	while (i2c_busy)
		;
	return I2CRXD;
}

void I2C_Isr(void) interrupt 24
{
	if (I2CMSST & 0x40)
	{
		I2CMSST &= ~0x40;
		i2c_busy = 0;
	}
}

float Read_Angle_Data(void)
{
	u8 a, b;
	u16 result;
	float angle;
	I2C_Addr(ADDR_W);
	I2C_Send_Data(0x03);
	I2C_Stop();
	I2C_Addr(ADDR_R);
	a = I2C_Read_End();
	I2C_Stop();
	I2C_Addr(ADDR_W);
	I2C_Send_Data(0x04);
	I2C_Stop();
	I2C_Addr(ADDR_R);
	b = I2C_Read_End();
	I2C_Stop();
	result = a << 8 | b;
	result >>= 2;
	angle = ((float)result/16384.0*360.0)*(PI/180);
	angle = angle*(float)DIR;
	return angle;
}

