#include "./H_Group/pid.h"

float PID_Ctrl(float error, PID_Register *p){
    // ѭмļʱ
    unsigned long int timestamp_now = Tick_Timer;
    float Ts = (timestamp_now - p->timestamp_prev) * 1e-6f;
    float proportional;
    float integral;
    float derivative;
    float output;
    float output_rate;
    if(Ts <= 0 || Ts > 0.5f) Ts = 1e-3f;
    
    // P
    proportional = p->P * error;
    // Tustin ɢ֣I
    integral = p->integral_prev + p->I*Ts*0.5f*(error + p->error_prev);
    integral = _constrain(integral, -(p->limit), p->limit);
    // D΢ֻڣ
    derivative = p->D*(error - p->error_prev)/Ts;

    // P,I,Dļֵ
    output = proportional + integral + derivative;
    output = _constrain(output, -(p->limit), p->limit);

    if(p->output_ramp > 0){
        // PIDı仯ʽ
        output_rate = (output - p->output_prev)/Ts;
        if (output_rate > p->output_ramp)
            output = p->output_prev + p->output_ramp*Ts;
        else if (output_rate < -(p->output_ramp))
            output = p->output_prev - p->output_ramp*Ts;
    }
    // ֵΪһѭ
    p->integral_prev = integral;
    p->output_prev = output;
    p->error_prev = error;
    p->timestamp_prev = timestamp_now;
    return output;
}