#include "./H_Group/adc.h"
#include "./H_Group/config.h"
#include "./H_Group/i2c.h"
#include "./H_Group/pid.h"
#include "./H_Group/pwm.h"
#include "./H_Group/uart.h"

// ̹߳
// ߳
#define Task_Max 20
// ָ߳
u8 Task = 0;
// ߳״̬
u8 Task_This[Task_Max] = {0};
// ߳˽жʱ
u16 Task_Timer[Task_Max] = {0};

// FOCͱ
#define _1_SQRT3 0.57735026919f
#define _2_SQRT3 1.15470053838f
float Ualpha, Ubeta = 0, Ua = 0, Ub = 0, Uc = 0;
#define _3PI_2 4.71238898038f
float zero_electric_angle = 0;

#define _ADC_VOLTAGE 5.0f		// ADC ѹ
#define _ADC_RESOLUTION 4095.0f // ADC ֱ
// ADC ѹת
#define _ADC_CONV ((_ADC_VOLTAGE) / (_ADC_RESOLUTION))
// ͨ˲ȫֱ
LowPassConfig lowpass_i1, lowpass_i2, lowpass_iq;
// PIDȫֱ
PID_Register pid_current, pid_speed, pid_pos;
// ȫּʱ
volatile unsigned long int Tick_Timer = 0;

// 
void Core_Init(void);
void Delay(unsigned int Time);
void Get_Delay(void);
void Timer1_Init(void);
void setTorque(float Uq, float angle_el);
float LowPassFilter(float x, LowPassConfig *p);					   // ͨ˲ʵֺ
float cal_Iq_Id(float current_a, float current_b, float angle_el); // iq
float xnjd = 0.0;
u8 zszt = 0;
bit zfz = 0;
bit run_flag = 0;
int iu = 0, iv = 0;
float i1, i2 = 0;
float iq = 0;
void main(void)
{
	Core_Init();
	Timer1_Init();
	I2C_Init();
	PWM_Init();
	ADC_Init();
	UART3_config(3); // ѡ, 2: ʹTimer2, ֵ: ʹTimer3.
	EA = 1;
	LED1 = LED2 = LED3 = LED4 = LED5 = 0; // رеLED
	MSD = 1;
	while (1)
	{
		if (KEY1 == 0)
			zfz = 0;
		if (KEY2 == 0)
			zfz = 1;
		if (KEY3 == 0)
			zszt = 0;
		if (KEY4 == 0)
			zszt = 1;
		if (KEY5 == 0)
			run_flag = 1;
		Task = 1;
		setTorque(1, xnjd);
		switch (Task_This[Task])
		{
		case 0:
		{
			if (run_flag)
			{
				LED1 = ~LED1;
				if (zfz)
					LED2 = 1;
				else
					LED2 = 0;
				if (zfz)
				{
					if (zszt)
						xnjd += 0.02;
					else
						xnjd += 0.01;
				}
				else
				{
					if (zszt)
						xnjd -= 0.02;
					else
						xnjd -= 0.01;
				}
				if (xnjd > 6.28)
					xnjd = 0, LED3 = ~LED3;
				if (xnjd < 0.0)
					xnjd = 6.28, LED4 = ~LED4;
				Delay(1);
			}
		}
		break;

		case 2:
		{
			Task_This[Task] = 0;
		}
		break;

		default:
		{
			Get_Delay();
		}
		break;
		}

		Task = 2;
		switch (Task_This[Task])
		{
		case 0:
		{
			iv = Get_ADC12bitResult(9);
			iu = Get_ADC12bitResult(10);
			i1 = LowPassFilter((((float)iu * _ADC_CONV) - 2.5) / 0.2, &lowpass_i1);
			i2 = LowPassFilter((((float)iv * _ADC_CONV) - 2.5) / 0.2, &lowpass_i2);
			iq = LowPassFilter(cal_Iq_Id(i1, i2, xnjd), &lowpass_iq);
			if (run_flag)
			{
				if (i1 >= 0)
					printf("t0.txt=\"  %1.1fA\"\xff\xff\xff", i1);
				else
					printf("t0.txt=\"-%1.1fA\"\xff\xff\xff", -i1);
				if (i2 >= 0)
					printf("t1.txt=\"  %1.1fA\"\xff\xff\xff", i2);
				else
					printf("t1.txt=\"-%1.1fA\"\xff\xff\xff", -i2);
				printf("t2.txt=\"%1.1fA\"\xff\xff\xff", iq);
				printf("add 13,0,%03d\xff\xff\xff", (int)(i1 * 5.0) + 50);
				printf("add 13,1,%03d\xff\xff\xff", (int)(i2 * 5.0) + 50);
				printf("t4.txt=\"%1.2frpm\"\xff\xff\xff", Read_Angle_Data());
			}
			else
			{
				// printf("t4.txt=\"%1.2frpm\"\xff\xff\xff", Read_Angle_Data());
				// DMA_Send_Start(); // һδDMA
			}
			DMA_Send_Start(); // һδDMA
			Delay(10);
		}
		break;

		case 2:
		{
			Task_This[Task] = 0;
		}
		break;

		default:
		{
			Get_Delay();
		}
		break;
		}

		Task = 3;
		switch (Task_This[Task])
		{
		case 0:
		{
			if (RX3_TimeOut > 0) // ʱ
			{
				if (--RX3_TimeOut == 0)
				{
					DMA_UR3R_CR = 0x00;//ֹͣ
					if (RX3_Buffer[1] == 0xff && RX3_Buffer[2] == 0xff && RX3_Buffer[3] == 0xff)
					{
						switch (RX3_Buffer[0])
						{
						case 'k':
							run_flag = 1;
							break;
						case 'z':
							run_flag = 0;
							break;
						case 'q':
							zfz = ~zfz;
							break;
						}
					}
					DMA_UR3R_CR = 0xa1;//ʼһν
				}
			}
			Delay(1);
		}
		break;

		case 2:
		{
			Task_This[Task] = 0;
		}
		break;

		default:
		{
			Get_Delay();
		}
		break;
		}
	};
}

void Open_ICache(void)
{
	bit fEA;
	if (WTST > 0)
	{
		fEA = EA;
		EA = 0;
		_nop_();
		_nop_();
		TA = 0xaa;
		TA = 0x55;
		ICHECR = 0x01; // дʱر
		_nop_();
		_nop_();
		EA = fEA;
	}
}

void Core_Init(void)
{
	EAXFR = 1;	  // ʹܷⲿXFR
	CKCON = 0x00; // ⲿٶΪ

	AUXR |= 0x80; // ʱʱ1Tģʽ
	TMOD &= 0xF0; // öʱģʽ
	TL0 = 0xB0;	  // öʱʼֵ@52Mhz/100us
	TH0 = 0xEB;	  // öʱʼֵ

	TF0 = 0; // TF0־
	TR0 = 1; // ʱ0ʼʱ
	ET0 = 1; // ʹܶʱ0ж

	// IOʼ
	P0M0 = 0x00;
	P0M1 = 0x1f;
	P1M0 = 0x00;
	P1M1 = 0x3e;
	P2M0 = 0x0f;
	P2M1 = 0xc0;
	P3M0 = 0x00;
	P3M1 = 0x7c;
	P4M0 = 0x00;
	P4M1 = 0xe1;
	P5M0 = 0x00;
	P5M1 = 0xf4;

	// 
	P3PU |= 0x80;
	P4PU |= 0x1e;

	Open_ICache(); // 򿪸ٻ

	// CREԶ׷Ƶ
	// Auto_Fre_Calibrator();
}

void Timer1_Isr(void) interrupt 3
{
	Tick_Timer++;
}

void Timer1_Init(void) // 1΢@52MHz
{
	AUXR |= 0x40; // ʱʱ1Tģʽ
	TMOD &= 0x0F; // öʱģʽ
	TMOD |= 0x20; // öʱģʽ
	TL1 = 0xCC;	  // öʱʼֵ
	TH1 = 0xCC;	  // öʱֵ
	TF1 = 0;	  // TF1־
	TR1 = 1;	  // ʱ1ʼʱ
	ET1 = 1;	  // ʹܶʱ1ж
}

#define Tf 0.01

// ͨ˲
float LowPassFilter(float x, LowPassConfig *p)
{
	unsigned long int time_temp = Tick_Timer;
	float dt = (time_temp - p->last_time) * 1e-6f;
	float alpha, y;
	if (dt < 0.0f)
		dt = 1e-3f;
	else if (dt > 0.3f)
	{
		p->last_result = x;
		p->last_time = time_temp;
		return x;
	}
	alpha = Tf / (Tf + dt);
	y = alpha * p->last_result + (1.0f - alpha) * x;
	p->last_result = y;
	p->last_time = time_temp;
	return y;
}

// ͨIa,Ib,IcIq,Id(ĿǰIq)
float cal_Iq_Id(float current_a, float current_b, float angle_el)
{
	float I_alpha = current_a;
	float I_beta = _1_SQRT3 * current_a + _2_SQRT3 * current_b;
	float ct = cos(angle_el);
	float st = sin(angle_el);
	// float I_d = I_alpha * ct + I_beta * st;
	float I_q = I_beta * ct - I_alpha * st;
	return I_q;
}

void Timer0_Isr(void) interrupt 1
{
	u8 i;

	// ̶߳ʱ
	for (i = 0; i < Task_Max; i++)
	{
		if (Task_Timer[i] > 0)
		{
			Task_Timer[i]--;
		}
	}
}

// ÷Ƕʱ̶1ms
void Delay(unsigned int Time)
{
	Task_Timer[Task] = Time;
	Task_This[Task]++;
}

// ȡǰʱ״̬
void Get_Delay(void)
{
	if (Task_Timer[Task] == 0)
	{
		Task_This[Task]++;
	}
	else
	{
		// ղ
	}
}

// һǶȵ [0,2PI]
float _normalizeAngle(float angle)
{
	float a = fmod(angle, 2 * PI); // ȡڹһгֵ֪
	return a >= 0 ? a : (a + 2 * PI);
	// Ŀʽcondition ? expr1 : expr2
	// Уcondition Ҫֵʽ򷵻 expr1 ֵ򷵻 expr2 ֵԽĿΪ if-else ļʽ
	// fmod ķͬˣ angle ֵΪʱķŽ _2PI ķ෴Ҳ˵ angle ֵС 0  _2PI ֵΪ fmod(angle, _2PI) Ϊ
	// 磬 angle ֵΪ -PI/2_2PI ֵΪ 2PI ʱfmod(angle, _2PI) һ£ͨ _2PI Ƕȹһ [0, 2PI] ķΧڣȷǶȵֵʼΪ
}

void setTorque(float Uq, float angle_el)
{
	float Ud;
	Uq = _constrain(Uq, -(voltage_power_supply) / 2, (voltage_power_supply) / 2);
	Ud = 0;
	angle_el = _normalizeAngle(angle_el);
	// 任
	Ualpha = -Uq * sin(angle_el);
	Ubeta = Uq * cos(angle_el);

	// 任
	Ua = Ualpha + voltage_power_supply / 2;
	Ub = (sqrt(3) * Ubeta - Ualpha) / 2 + voltage_power_supply / 2;
	Uc = (-Ualpha - sqrt(3) * Ubeta) / 2 + voltage_power_supply / 2;
	setPwm(Ua, Ub, Uc);
}
